//import 'package:http/http.dart' as http;
import 'dart:io';
import 'package:archive/archive.dart';

main() async {
  // var shell = shell();
  // await shell.run();

  var url =
      "http://yx-web.nos.netease.com/package/1635305057/NIM_CrossPlatform_SDK_v8.7.3.zip";
  var tmpdir = "./nim_sdk";
  var sdkFile = "nim_sdk.zip";
  var sdk = tmpdir + "/" + sdkFile;

  if (File(sdk).existsSync()) {
    print("[downloadSDK]: sdk existing.");
    return;
  }

  await Directory(tmpdir).create(recursive: true);

  print("[downloadSDK]: start download sdk from $url.");
  final request = await HttpClient().getUrl(Uri.parse(url));
  final response = await request.close();
  await response.pipe(File(sdk).openWrite());
  print("[downloadSDK]: download the end.");

  print("[downloadSDK]: start decompressing.");
  var sdk_platFile = "";
  final bytes = new File(sdk).readAsBytesSync();
  final archive = new ZipDecoder().decodeBytes(bytes);
  for (var file in archive) {
    final filename = '${file.name}';
    if (file.isFile) {
      if (filename.contains('windows') && filename.contains('x64')) {
      } else {
        continue;
      }

      sdk_platFile = tmpdir + '/' + filename;
      var outFile = new File(sdk_platFile);
      outFile = await outFile.create(recursive: true);
      await outFile.writeAsBytes(file.content);
    } else {
      await new Directory(tmpdir + '/' + filename).create(recursive: true);
    }
  }

  if (!sdk_platFile.isEmpty) {
    print("[downloadSDK]: decompressing $sdk_platFile.");
    final bytesTmp = new File(sdk_platFile).readAsBytesSync();
    final archiveTmpData = new GZipDecoder().decodeBytes(bytesTmp);
    final archiveTmp = new TarDecoder().decodeBytes(archiveTmpData);
    for (var file in archiveTmp) {
      final filename = '${file.name}';
      if (file.isFile) {
        var macFile = tmpdir + '/' + filename;
        var outFile = new File(macFile);
        outFile = await outFile.create(recursive: true);
        await outFile.writeAsBytes(file.content);
      } else {
        await new Directory(tmpdir + '/' + filename).create(recursive: true);
      }
    }

    File(sdk_platFile).delete();
    print("[downloadSDK]: decompression end(successfull).");
  } else {
    print("[downloadSDK]: decompression end(failed).");
  }
}
