// Copyright (c) 2021 NetEase, Inc.  All rights reserved.
// Use of this source code is governed by a MIT license that can be
// found in the LICENSE file.

#include "FLTService.h"
#include "FLTConvert.h"

std::string FLTService::getServiceName() const {
    return m_serviceName;
}

void FLTService::notifyEvent(const std::string& eventName, flutter::EncodableMap arguments) {
    arguments.insert(std::make_pair(flutter::EncodableValue("serviceName"), flutter::EncodableValue(m_serviceName)));
    std::unique_ptr<flutter::EncodableValue> arguments_ = std::make_unique<flutter::EncodableValue>(arguments);

    YXLOG_API(Info) << "serviceName: " << m_serviceName << ", eventName: " << eventName
                    << ", arguments: " << Convert::getInstance()->getStringFormMapForLog(&arguments) << YXLOGEnd;
    NimCore::getInstance()->getMethodChannel()->InvokeMethod(eventName, std::move(arguments_));
}

void FLTService::notifyEventEx(const std::string& serviceName, const std::string& eventName, flutter::EncodableMap arguments) {
    arguments.insert(std::make_pair(flutter::EncodableValue("serviceName"), flutter::EncodableValue(serviceName)));
    std::unique_ptr<flutter::EncodableValue> arguments_ = std::make_unique<flutter::EncodableValue>(arguments);

    YXLOG_API(Info) << "serviceName: " << serviceName << ", eventName: " << eventName
                    << ", arguments: " << Convert::getInstance()->getStringFormMapForLog(&arguments) << YXLOGEnd;
    NimCore::getInstance()->getMethodChannel()->InvokeMethod(eventName, std::move(arguments_));
}